diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/test/wifi-txop-test.cc ns-3.42/src/wifi/test/wifi-txop-test.cc
--- ns-3.41/src/wifi/test/wifi-txop-test.cc	2024-02-09 14:44:08.617795200 -0800
+++ ns-3.42/src/wifi/test/wifi-txop-test.cc	2024-05-29 15:29:47.220074000 -0700
@@ -659,180 +901,262 @@
     tEnd = m_txPsdus[14].txStart + m_txPsdus[14].txDuration;
     tStart = m_txPsdus[15].txStart;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs, tStart, "First QoS data frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart, tEnd + sifs + tolerance, "First QoS data frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[15].header.IsQosData(), true, "Expected a QoS data frame");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[15].header.GetAddr1(),
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "First QoS data frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "First QoS data frame sent too late");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[15].header.IsQosData(), true, "Expected a QoS data frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[15].header.GetAddr1(),
                           DynamicCast<WifiNetDevice>(m_staDevices.Get(0))->GetMac()->GetAddress(),
                           "Expected a frame sent by the AP to the first station");
-    NS_TEST_ASSERT_MSG_EQ(
+    if (m_lengthBasedRtsCtsThresh)
+    {
+        NS_TEST_EXPECT_MSG_GT(m_txPsdus[15].size,
+                              rtsCtsThreshold,
+                              "PSDU size expected to exceed length based RTS/CTS threshold");
+    }
+    else
+    {
+        NS_TEST_EXPECT_MSG_GT(m_txPsdus[15].txDuration,
+                              rtsCtsTxDurationThresh,
+                              "PSDU duration expected to exceed duration based RTS/CTS threshold");
+    }
+    NS_TEST_EXPECT_MSG_EQ(
         m_txPsdus[15].header.GetDuration(),
-        RoundDurationId(m_txopLimit - (m_txPsdus[15].txStart - txopStart) -
+        RoundDurationId(m_apTxopLimit - (m_txPsdus[15].txStart - txopStart) -
                         m_txPsdus[15].txDuration),
         "Duration/ID of the first QoS data frame does not cover the remaining TXOP");
 
-    // a Normal Ack is then sent by STA1
+    // a Normal/Block Ack is then sent by STA1
     tEnd = m_txPsdus[15].txStart + m_txPsdus[15].txDuration;
     tStart = m_txPsdus[16].txStart;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs,
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs,
                           tStart,
-                          "Ack in response to the first QoS data frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart,
+                          ack << " in response to the first QoS data frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
-                          "Ack in response to the first QoS data frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[16].header.IsAck(), true, "Expected a Normal Ack");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[16].header.GetAddr1(),
-                          DynamicCast<WifiNetDevice>(m_apDevices.Get(0))->GetMac()->GetAddress(),
-                          "Expected a Normal Ack sent to the AP");
-    NS_TEST_ASSERT_MSG_EQ(
+                          ack << " in response to the first QoS data frame sent too late");
+    NS_TEST_EXPECT_MSG_EQ(
+        (m_nonHt ? m_txPsdus[16].header.IsAck() : m_txPsdus[16].header.IsBlockAck()),
+        true,
+        "Expected a " << ack);
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[16].header.GetAddr1(),
+                          apDev->GetMac()->GetAddress(),
+                          "Expected a " << ack << " sent to the AP");
+    NS_TEST_EXPECT_MSG_EQ(
         m_txPsdus[16].header.GetDuration(),
         RoundDurationId(m_txPsdus[15].header.GetDuration() - sifs - m_txPsdus[16].txDuration),
-        "Duration/ID of the Ack must be derived from that of the previous frame");
+        "Duration/ID of the " << ack << " must be derived from that of the previous frame");
 
-    // An RTS frame is sent by the AP to STA2
-    tEnd = m_txPsdus[16].txStart + m_txPsdus[16].txDuration;
-    tStart = m_txPsdus[17].txStart;
-
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs, tStart, "Second RTS frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart, tEnd + sifs + tolerance, "Second RTS frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[17].header.IsRts(), true, "Expected an RTS frame");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[17].header.GetAddr1(),
-                          DynamicCast<WifiNetDevice>(m_staDevices.Get(1))->GetMac()->GetAddress(),
-                          "Expected an RTS frame sent by the AP to the second station");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[17].header.GetDuration(),
-                          RoundDurationId(m_txopLimit - (m_txPsdus[17].txStart - txopStart) -
-                                          m_txPsdus[17].txDuration),
-                          "Duration/ID of the second RTS frame must cover the whole TXOP");
-
-    // a CTS is sent by STA2 (which ignores the NAV)
-    tEnd = m_txPsdus[17].txStart + m_txPsdus[17].txDuration;
-    tStart = m_txPsdus[18].txStart;
+    std::size_t idx = 16;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs,
-                          tStart,
-                          "CTS in response to the second RTS frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart,
-                          tEnd + sifs + tolerance,
-                          "CTS in response to the second RTS frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[18].header.IsCts(), true, "Expected a CTS");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[18].header.GetAddr1(),
-                          DynamicCast<WifiNetDevice>(m_apDevices.Get(0))->GetMac()->GetAddress(),
-                          "Expected a CTS frame sent to the AP");
-    NS_TEST_ASSERT_MSG_EQ(
-        m_txPsdus[18].header.GetDuration(),
-        RoundDurationId(m_txPsdus[17].header.GetDuration() - sifs - m_txPsdus[18].txDuration),
-        "Duration/ID of the CTS frame must be derived from that of the RTS frame");
+    if (!m_singleRtsPerTxop)
+    {
+        // An RTS frame is sent by the AP to STA2
+        tEnd = m_txPsdus[idx].txStart + m_txPsdus[idx].txDuration;
+        ++idx;
+        tStart = m_txPsdus[idx].txStart;
+
+        NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Second RTS frame sent too early");
+        NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "Second RTS frame sent too late");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx].header.IsRts(), true, "Expected an RTS frame");
+        NS_TEST_EXPECT_MSG_EQ(
+            m_txPsdus[idx].header.GetAddr1(),
+            DynamicCast<WifiNetDevice>(m_staDevices.Get(1))->GetMac()->GetAddress(),
+            "Expected an RTS frame sent by the AP to the second station");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx].header.GetDuration(),
+                              RoundDurationId(m_apTxopLimit - (m_txPsdus[idx].txStart - txopStart) -
+                                              m_txPsdus[idx].txDuration),
+                              "Duration/ID of the second RTS frame must cover the whole TXOP");
+
+        // a CTS is sent by STA2 (which ignores the NAV)
+        tEnd = m_txPsdus[idx].txStart + m_txPsdus[idx].txDuration;
+        tStart = m_txPsdus[idx + 1].txStart;
 
-    // the AP sends a frame to STA2
-    tEnd = m_txPsdus[18].txStart + m_txPsdus[18].txDuration;
-    tStart = m_txPsdus[19].txStart;
+        NS_TEST_EXPECT_MSG_LT(tEnd + sifs,
+                              tStart,
+                              "CTS in response to the second RTS frame sent too early");
+        NS_TEST_EXPECT_MSG_LT(tStart,
+                              tEnd + sifs + tolerance,
+                              "CTS in response to the second RTS frame sent too late");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx + 1].header.IsCts(), true, "Expected a CTS");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx + 1].header.GetAddr1(),
+                              apDev->GetMac()->GetAddress(),
+                              "Expected a CTS frame sent to the AP");
+        NS_TEST_EXPECT_MSG_EQ(
+            m_txPsdus[idx + 1].header.GetDuration(),
+            RoundDurationId(m_txPsdus[idx].header.GetDuration() - sifs -
+                            m_txPsdus[idx + 1].txDuration),
+            "Duration/ID of the CTS frame must be derived from that of the RTS frame");
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs, tStart, "Second QoS data frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart, tEnd + sifs + tolerance, "Second QoS data frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[19].header.IsQosData(), true, "Expected a QoS data frame");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[19].header.GetAddr1(),
+        ++idx;
+    }
+
+    // the AP sends a frame to STA2
+    tEnd = m_txPsdus[idx].txStart + m_txPsdus[idx].txDuration;
+    ++idx;
+    tStart = m_txPsdus[idx].txStart;
+
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Second QoS data frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "Second QoS data frame sent too late");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx].header.IsQosData(), true, "Expected a QoS data frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx].header.GetAddr1(),
                           DynamicCast<WifiNetDevice>(m_staDevices.Get(1))->GetMac()->GetAddress(),
                           "Expected a frame sent by the AP to the second station");
-    NS_TEST_ASSERT_MSG_EQ(
-        m_txPsdus[19].header.GetDuration(),
-        RoundDurationId(m_txopLimit - (m_txPsdus[19].txStart - txopStart) -
-                        m_txPsdus[19].txDuration),
+    if (m_lengthBasedRtsCtsThresh)
+    {
+        NS_TEST_EXPECT_MSG_GT(m_txPsdus[idx].size,
+                              rtsCtsThreshold,
+                              "PSDU size expected to exceed length based RTS/CTS threshold");
+    }
+    else
+    {
+        NS_TEST_EXPECT_MSG_GT(m_txPsdus[idx].txDuration,
+                              rtsCtsTxDurationThresh,
+                              "PSDU duration expected to exceed duration based RTS/CTS threshold");
+    }
+    NS_TEST_EXPECT_MSG_EQ(
+        m_txPsdus[idx].header.GetDuration(),
+        RoundDurationId(m_apTxopLimit - (m_txPsdus[idx].txStart - txopStart) -
+                        m_txPsdus[idx].txDuration),
         "Duration/ID of the second QoS data frame does not cover the remaining TXOP");
 
-    // a Normal Ack is then sent by STA2
-    tEnd = m_txPsdus[19].txStart + m_txPsdus[19].txDuration;
-    tStart = m_txPsdus[20].txStart;
+    // a Normal/Block Ack is then sent by STA2
+    tEnd = m_txPsdus[idx].txStart + m_txPsdus[idx].txDuration;
+    tStart = m_txPsdus[idx + 1].txStart;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs,
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs,
                           tStart,
-                          "Ack in response to the second QoS data frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart,
+                          ack << " in response to the second QoS data frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
-                          "Ack in response to the second QoS data frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[20].header.IsAck(), true, "Expected a Normal Ack");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[20].header.GetAddr1(),
-                          DynamicCast<WifiNetDevice>(m_apDevices.Get(0))->GetMac()->GetAddress(),
-                          "Expected a Normal Ack sent to the AP");
-    NS_TEST_ASSERT_MSG_EQ(
-        m_txPsdus[20].header.GetDuration(),
-        RoundDurationId(m_txPsdus[19].header.GetDuration() - sifs - m_txPsdus[20].txDuration),
-        "Duration/ID of the Ack must be derived from that of the previous frame");
+                          ack << " in response to the second QoS data frame sent too late");
+    NS_TEST_EXPECT_MSG_EQ(
+        (m_nonHt ? m_txPsdus[idx + 1].header.IsAck() : m_txPsdus[idx + 1].header.IsBlockAck()),
+        true,
+        "Expected a " << ack);
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx + 1].header.GetAddr1(),
+                          apDev->GetMac()->GetAddress(),
+                          "Expected a " << ack << " sent to the AP");
+    NS_TEST_EXPECT_MSG_EQ(
+        m_txPsdus[idx + 1].header.GetDuration(),
+        RoundDurationId(m_txPsdus[idx].header.GetDuration() - sifs - m_txPsdus[idx + 1].txDuration),
+        "Duration/ID of the " << ack << " must be derived from that of the previous frame");
+    ++idx;
 
-    // An RTS frame is sent by the AP to STA3
-    tEnd = m_txPsdus[20].txStart + m_txPsdus[20].txDuration;
-    tStart = m_txPsdus[21].txStart;
-
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs, tStart, "Third RTS frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart, tEnd + sifs + tolerance, "Third RTS frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[21].header.IsRts(), true, "Expected an RTS frame");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[21].header.GetAddr1(),
-                          DynamicCast<WifiNetDevice>(m_staDevices.Get(2))->GetMac()->GetAddress(),
-                          "Expected an RTS frame sent by the AP to the third station");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[21].header.GetDuration(),
-                          RoundDurationId(m_txopLimit - (m_txPsdus[21].txStart - txopStart) -
-                                          m_txPsdus[21].txDuration),
-                          "Duration/ID of the third RTS frame must cover the whole TXOP");
-
-    // a CTS is sent by STA3 (which ignores the NAV)
-    tEnd = m_txPsdus[21].txStart + m_txPsdus[21].txDuration;
-    tStart = m_txPsdus[22].txStart;
+    if (!m_singleRtsPerTxop)
+    {
+        // An RTS frame is sent by the AP to STA3
+        tEnd = m_txPsdus[idx].txStart + m_txPsdus[idx].txDuration;
+        ++idx;
+        tStart = m_txPsdus[idx].txStart;
+
+        NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Third RTS frame sent too early");
+        NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "Third RTS frame sent too late");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx].header.IsRts(), true, "Expected an RTS frame");
+        NS_TEST_EXPECT_MSG_EQ(
+            m_txPsdus[idx].header.GetAddr1(),
+            DynamicCast<WifiNetDevice>(m_staDevices.Get(2))->GetMac()->GetAddress(),
+            "Expected an RTS frame sent by the AP to the third station");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx].header.GetDuration(),
+                              RoundDurationId(m_apTxopLimit - (m_txPsdus[idx].txStart - txopStart) -
+                                              m_txPsdus[idx].txDuration),
+                              "Duration/ID of the third RTS frame must cover the whole TXOP");
+
+        // a CTS is sent by STA3 (which ignores the NAV)
+        tEnd = m_txPsdus[idx].txStart + m_txPsdus[idx].txDuration;
+        tStart = m_txPsdus[idx + 1].txStart;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs,
-                          tStart,
-                          "CTS in response to the third RTS frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart,
-                          tEnd + sifs + tolerance,
-                          "CTS in response to the third RTS frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[22].header.IsCts(), true, "Expected a CTS");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[22].header.GetAddr1(),
-                          DynamicCast<WifiNetDevice>(m_apDevices.Get(0))->GetMac()->GetAddress(),
-                          "Expected a CTS frame sent to the AP");
-    NS_TEST_ASSERT_MSG_EQ(
-        m_txPsdus[22].header.GetDuration(),
-        RoundDurationId(m_txPsdus[21].header.GetDuration() - sifs - m_txPsdus[22].txDuration),
-        "Duration/ID of the CTS frame must be derived from that of the RTS frame");
+        NS_TEST_EXPECT_MSG_LT(tEnd + sifs,
+                              tStart,
+                              "CTS in response to the third RTS frame sent too early");
+        NS_TEST_EXPECT_MSG_LT(tStart,
+                              tEnd + sifs + tolerance,
+                              "CTS in response to the third RTS frame sent too late");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx + 1].header.IsCts(), true, "Expected a CTS");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx + 1].header.GetAddr1(),
+                              apDev->GetMac()->GetAddress(),
+                              "Expected a CTS frame sent to the AP");
+        NS_TEST_EXPECT_MSG_EQ(
+            m_txPsdus[idx + 1].header.GetDuration(),
+            RoundDurationId(m_txPsdus[idx].header.GetDuration() - sifs -
+                            m_txPsdus[idx + 1].txDuration),
+            "Duration/ID of the CTS frame must be derived from that of the RTS frame");
+        ++idx;
+    }
 
     // the AP sends a frame to STA3
-    tEnd = m_txPsdus[22].txStart + m_txPsdus[22].txDuration;
-    tStart = m_txPsdus[23].txStart;
-
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs, tStart, "Third QoS data frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart, tEnd + sifs + tolerance, "Third QoS data frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[23].header.IsQosData(), true, "Expected a QoS data frame");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[23].header.GetAddr1(),
+    tEnd = m_txPsdus[idx].txStart + m_txPsdus[idx].txDuration;
+    ++idx;
+    tStart = m_txPsdus[idx].txStart;
+
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Third QoS data frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "Third QoS data frame sent too late");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx].header.IsQosData(), true, "Expected a QoS data frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx].header.GetAddr1(),
                           DynamicCast<WifiNetDevice>(m_staDevices.Get(2))->GetMac()->GetAddress(),
                           "Expected a frame sent by the AP to the third station");
-    NS_TEST_ASSERT_MSG_EQ(
-        m_txPsdus[23].header.GetDuration(),
-        RoundDurationId(m_txopLimit - (m_txPsdus[23].txStart - txopStart) -
-                        m_txPsdus[23].txDuration),
+    if (m_lengthBasedRtsCtsThresh)
+    {
+        NS_TEST_EXPECT_MSG_GT(m_txPsdus[idx].size,
+                              rtsCtsThreshold,
+                              "PSDU size expected to exceed length based RTS/CTS threshold");
+    }
+    else
+    {
+        NS_TEST_EXPECT_MSG_GT(m_txPsdus[idx].txDuration,
+                              rtsCtsTxDurationThresh,
+                              "PSDU duration expected to exceed duration based RTS/CTS threshold");
+    }
+    NS_TEST_EXPECT_MSG_EQ(
+        m_txPsdus[idx].header.GetDuration(),
+        RoundDurationId(m_apTxopLimit - (m_txPsdus[idx].txStart - txopStart) -
+                        m_txPsdus[idx].txDuration),
         "Duration/ID of the third QoS data frame does not cover the remaining TXOP");
 
-    // a Normal Ack is then sent by STA3
-    tEnd = m_txPsdus[23].txStart + m_txPsdus[23].txDuration;
-    tStart = m_txPsdus[24].txStart;
+    // a Normal/Block Ack is then sent by STA3
+    tEnd = m_txPsdus[idx].txStart + m_txPsdus[idx].txDuration;
+    tStart = m_txPsdus[idx + 1].txStart;
 
-    NS_TEST_ASSERT_MSG_LT(tEnd + sifs,
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs,
                           tStart,
-                          "Ack in response to the third QoS data frame sent too early");
-    NS_TEST_ASSERT_MSG_LT(tStart,
+                          ack << " in response to the third QoS data frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart,
                           tEnd + sifs + tolerance,
-                          "Ack in response to the third QoS data frame sent too late");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[24].header.IsAck(), true, "Expected a Normal Ack");
-    NS_TEST_ASSERT_MSG_EQ(m_txPsdus[24].header.GetAddr1(),
-                          DynamicCast<WifiNetDevice>(m_apDevices.Get(0))->GetMac()->GetAddress(),
-                          "Expected a Normal Ack sent to the AP");
-    NS_TEST_ASSERT_MSG_EQ(
-        m_txPsdus[24].header.GetDuration(),
-        RoundDurationId(m_txPsdus[23].header.GetDuration() - sifs - m_txPsdus[24].txDuration),
-        "Duration/ID of the Ack must be derived from that of the previous frame");
-
-    // there is no time remaining for sending a CF-End frame. This is verified by checking
-    // that 25 frames are transmitted (done at the beginning of this method)
+                          ack << " in response to the third QoS data frame sent too late");
+    NS_TEST_EXPECT_MSG_EQ(
+        (m_nonHt ? m_txPsdus[idx + 1].header.IsAck() : m_txPsdus[idx + 1].header.IsBlockAck()),
+        true,
+        "Expected a " << ack);
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx + 1].header.GetAddr1(),
+                          apDev->GetMac()->GetAddress(),
+                          "Expected a " << ack << " sent to the AP");
+    NS_TEST_EXPECT_MSG_EQ(
+        m_txPsdus[idx + 1].header.GetDuration(),
+        RoundDurationId(m_txPsdus[idx].header.GetDuration() - sifs - m_txPsdus[idx + 1].txDuration),
+        "Duration/ID of the " << ack << " must be derived from that of the previous frame");
+    ++idx;
+
+    // there is no time remaining for sending a CF-End frame if SingleRtsPerTxop is false. This is
+    // verified by checking that 25 frames are transmitted (done at the beginning of this method)
+    if (m_singleRtsPerTxop)
+    {
+        tEnd = m_txPsdus[idx].txStart + m_txPsdus[idx].txDuration;
+        ++idx;
+        tStart = m_txPsdus[idx].txStart;
+
+        NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CF-End sent too early");
+        NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CF-End sent too late");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx].header.IsCfEnd(), true, "Expected a CF-End frame");
+        NS_TEST_EXPECT_MSG_EQ(m_txPsdus[idx].header.GetDuration(),
+                              Seconds(0),
+                              "Duration/ID must be set to 0 for CF-End frames");
+    }
 
-    // 3 DL packets (without RTS/CTS), 1 UL packet and 3 DL packets (with RTS/CTS)
-    NS_TEST_ASSERT_MSG_EQ(m_received, 7, "Unexpected number of packets received");
+    // Expected received packets:
+    // - 3 DL packets (without RTS/CTS)
+    // - 1 UL packet
+    // - 3 DL packets (with RTS/CTS) if non-HT, 6 DL packets (with RTS/CTS) if HE
+    NS_TEST_EXPECT_MSG_EQ(m_received, (m_nonHt ? 7 : 10), "Unexpected number of packets received");
 }
 
 /**
@@ -848,10 +1172,26 @@
 };
 
 WifiTxopTestSuite::WifiTxopTestSuite()
-    : TestSuite("wifi-txop", UNIT)
+    : TestSuite("wifi-txop", Type::UNIT)
 {
-    AddTestCase(new WifiTxopTest(true), TestCase::QUICK);
-    AddTestCase(new WifiTxopTest(false), TestCase::QUICK);
+    for (const auto nonHt : {true, false})
+    {
+        AddTestCase(new WifiTxopTest({.nonHt = nonHt,
+                                      .pifsRecovery = true,
+                                      .singleRtsPerTxop = false,
+                                      .lengthBasedRtsCtsThresh = false}),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new WifiTxopTest({.nonHt = nonHt,
+                                      .pifsRecovery = false,
+                                      .singleRtsPerTxop = true,
+                                      .lengthBasedRtsCtsThresh = false}),
+                    TestCase::Duration::QUICK);
+        AddTestCase(new WifiTxopTest({.nonHt = nonHt,
+                                      .pifsRecovery = true,
+                                      .singleRtsPerTxop = true,
+                                      .lengthBasedRtsCtsThresh = true}),
+                    TestCase::Duration::QUICK);
+    }
 }
 
 static WifiTxopTestSuite g_wifiTxopTestSuite; ///< the test suite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/helper/wimax-helper.cc ns-3.42/src/wimax/helper/wimax-helper.cc
--- ns-3.41/src/wimax/helper/wimax-helper.cc	2024-02-09 14:44:08.617795200 -0800
+++ ns-3.42/src/wimax/helper/wimax-helper.cc	2024-05-29 15:29:47.220074000 -0700
@@ -442,14 +442,14 @@
 
 ServiceFlow
 WimaxHelper::CreateServiceFlow(ServiceFlow::Direction direction,
-                               ServiceFlow::SchedulingType schedulinType,
+                               ServiceFlow::SchedulingType schedulingType,
                                IpcsClassifierRecord classifier)
 {
     CsParameters csParam(CsParameters::ADD, classifier);
     ServiceFlow serviceFlow = ServiceFlow(direction);
     serviceFlow.SetConvergenceSublayerParam(csParam);
     serviceFlow.SetCsSpecification(ServiceFlow::IPV4);
-    serviceFlow.SetServiceSchedulingType(schedulinType);
+    serviceFlow.SetServiceSchedulingType(schedulingType);
     serviceFlow.SetMaxSustainedTrafficRate(100);
     serviceFlow.SetMinReservedTrafficRate(1000000);
     serviceFlow.SetMinTolerableTrafficRate(1000000);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/helper/wimax-helper.h ns-3.42/src/wimax/helper/wimax-helper.h
--- ns-3.41/src/wimax/helper/wimax-helper.h	2024-02-09 14:44:08.617795200 -0800
+++ ns-3.42/src/wimax/helper/wimax-helper.h	2024-05-29 15:29:47.220074000 -0700
@@ -245,13 +245,13 @@
     /**
      * \brief Creates a transport service flow.
      * \param direction the direction of the service flow: UP or DOWN.
-     * \param schedulinType The service scheduling type to be used: UGS, RTPS, NRTPS, BE
+     * \param schedulingType The service scheduling type to be used: UGS, RTPS, NRTPS, BE
      * \param classifier The classifier to be used for this service flow
      * \return ServiceFlow
      *
      */
     ServiceFlow CreateServiceFlow(ServiceFlow::Direction direction,
-                                  ServiceFlow::SchedulingType schedulinType,
+                                  ServiceFlow::SchedulingType schedulingType,
                                   IpcsClassifierRecord classifier);
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/model/bandwidth-manager.cc ns-3.42/src/wimax/model/bandwidth-manager.cc
--- ns-3.41/src/wimax/model/bandwidth-manager.cc	2024-02-09 14:44:08.617795200 -0800
+++ ns-3.42/src/wimax/model/bandwidth-manager.cc	2024-05-29 15:29:47.220074000 -0700
@@ -98,13 +98,9 @@
         }
     }
     break;
-    case ServiceFlow::SF_TYPE_NRTPS: {
+    case ServiceFlow::SF_TYPE_NRTPS:
         /* nrtPS shall be serviced only if sufficient bandwidth is available after servicing
          UGS and rtPS scheduling types, hence no specific service interval is used */
-
-        allocationSize = bs->GetBwReqOppSize();
-    }
-    break;
     case ServiceFlow::SF_TYPE_BE: {
         /* BE shall be serviced only if sufficient bandwidth is available after servicing
          the rest of three scheduling types, hence no specific service interval is used */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/model/bs-net-device.cc ns-3.42/src/wimax/model/bs-net-device.cc
--- ns-3.41/src/wimax/model/bs-net-device.cc	2024-02-09 14:44:08.617795200 -0800
+++ ns-3.42/src/wimax/model/bs-net-device.cc	2024-05-29 15:29:47.224074000 -0700
@@ -790,7 +790,6 @@
             {
             case ManagementMessageType::MESSAGE_TYPE_REG_REQ:
                 // not yet implemented
-                break;
             case ManagementMessageType::MESSAGE_TYPE_REG_RSP:
                 // from other base station, ignore
                 break;
@@ -831,7 +830,7 @@
                 C_Packet->RemoveHeader(llc);
                 source = m_ssManager->GetMacAddress(cid);
                 m_bsRxTrace(packet);
-                ForwardUp(packet->Copy(), source, Mac48Address("ff:ff:ff:ff:ff:ff"));
+                ForwardUp(packet->Copy(), source, Mac48Address::GetBroadcast());
             }
             else
             {
@@ -861,7 +860,7 @@
                     NS_LOG_INFO("\t fullPacket size = " << fullPacket->GetSize() << std::endl);
                     source = m_ssManager->GetMacAddress(cid);
                     m_bsRxTrace(fullPacket);
-                    ForwardUp(fullPacket->Copy(), source, Mac48Address("ff:ff:ff:ff:ff:ff"));
+                    ForwardUp(fullPacket->Copy(), source, Mac48Address::GetBroadcast());
                 }
                 else
                 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/model/bs-service-flow-manager.cc ns-3.42/src/wimax/model/bs-service-flow-manager.cc
--- ns-3.41/src/wimax/model/bs-service-flow-manager.cc	2024-02-09 14:44:08.621795200 -0800
+++ ns-3.42/src/wimax/model/bs-service-flow-manager.cc	2024-05-29 15:29:47.224074000 -0700
@@ -169,7 +169,7 @@
     ssRecord->IncrementDsaRspRetries();
     p->AddHeader(ManagementMessageType(ManagementMessageType::MESSAGE_TYPE_DSA_RSP));
 
-    if (m_dsaAckTimeoutEvent.IsRunning())
+    if (m_dsaAckTimeoutEvent.IsPending())
     {
         Simulator::Cancel(m_dsaAckTimeoutEvent);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/model/bs-uplink-scheduler-mbqos.cc ns-3.42/src/wimax/model/bs-uplink-scheduler-mbqos.cc
--- ns-3.41/src/wimax/model/bs-uplink-scheduler-mbqos.cc	2024-02-09 14:44:08.621795200 -0800
+++ ns-3.42/src/wimax/model/bs-uplink-scheduler-mbqos.cc	2024-05-29 15:29:47.224074000 -0700
@@ -1178,14 +1178,10 @@
     switch (serviceFlow->GetSchedulingType())
     {
     case ServiceFlow::SF_TYPE_RTPS:
-        EnqueueJob(UlJob::INTERMEDIATE, job);
-        break;
     case ServiceFlow::SF_TYPE_NRTPS:
         EnqueueJob(UlJob::INTERMEDIATE, job);
         break;
     case ServiceFlow::SF_TYPE_BE:
-        EnqueueJob(UlJob::LOW, job);
-        break;
     default:
         EnqueueJob(UlJob::LOW, job);
         break;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/model/bs-uplink-scheduler-rtps.cc ns-3.42/src/wimax/model/bs-uplink-scheduler-rtps.cc
--- ns-3.41/src/wimax/model/bs-uplink-scheduler-rtps.cc	2024-02-09 14:44:08.621795200 -0800
+++ ns-3.42/src/wimax/model/bs-uplink-scheduler-rtps.cc	2024-05-29 15:29:47.224074000 -0700
@@ -720,14 +720,11 @@
         serviceFlow->SetUnsolicitedPollingInterval(interval);
     }
     break;
-    case ServiceFlow::SF_TYPE_NRTPS: {
+    case ServiceFlow::SF_TYPE_NRTPS:
         // no real-time guarantees are given to NRTPS, serviced based on available bandwidth
-    }
-    break;
-    case ServiceFlow::SF_TYPE_BE: {
+    case ServiceFlow::SF_TYPE_BE:
         // no real-time guarantees are given to BE, serviced based on available bandwidth
-    }
-    break;
+        break;
     default:
         NS_FATAL_ERROR("Invalid scheduling type");
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wimax/model/bs-uplink-scheduler-simple.cc ns-3.42/src/wimax/model/bs-uplink-scheduler-simple.cc
--- ns-3.41/src/wimax/model/bs-uplink-scheduler-simple.cc	2024-02-09 14:44:08.621795200 -0800
+++ ns-3.42/src/wimax/model/bs-uplink-scheduler-simple.cc	2024-05-29 15:29:47.224074000 -0700
@@ -569,14 +569,11 @@
         serviceFlow->SetUnsolicitedPollingInterval(interval);
     }
     break;
-    case ServiceFlow::SF_TYPE_NRTPS: {
+    case ServiceFlow::SF_TYPE_NRTPS:
         // no real-time guarantees are given to NRTPS, serviced based on available bandwidth
-    }
-    break;
-    case ServiceFlow::SF_TYPE_BE: {
+    case ServiceFlow::SF_TYPE_BE:
         // no real-time guarantees are given to BE, serviced based on available bandwidth
-    }
-    break;
+        break;
     default:
         NS_FATAL_ERROR("Invalid scheduling type");
     }
